#include <iostream>
#include <vector>

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data()
{
    Input in;
    size_t number_count;
    cin >> number_count;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        cin >> in.numbers[i];
    }
    cin >> in.bin_count;
    return in;
}

void find_minmax(const vector<double> &numbers, double &min, double &max)
{
    min = numbers[0];
    max = numbers[0];
    for (auto el : numbers)
    {
        if (el > max)
        {
            max = el;
        }
        if (el < min)
        {
            min = el;
        }
    }
}

vector<size_t> make_histogram(const vector<double> &numbers, const size_t &bin_count){
        vector<size_t> bins(bin_count);
        double max, min;
        find_minmax(numbers, min, max);
        double binSize = (max - min) / bin_count;
        for (size_t i = 0; i < numbers.size(); i++)
        {
            bool found = false;
            for (size_t j = 0; (j < bin_count - 1) && !found; j++)
            {
                auto lo = min + j * binSize;
                auto hi = min + (j + 1) * binSize;
                if ((lo <= numbers[i]) && (numbers[i] < hi))
                {
                    bins[j]++;
                    found = true;
                }
            }
            if (!found)
            {
                bins[bin_count - 1]++;
            }
        }
        return bins;
    }

void show_histogram_text(const vector<size_t> &bins){
        size_t maxCount = bins[0];
        for (auto bin : bins)
        {
            if (maxCount < bin)
            {
                maxCount = bin;
            }
        }
        for (auto bin : bins)
        {
            if (bin < 100)
            {
                cout << " ";
            }
            if (bin < 10)
            {
                cout << " ";
            }
            size_t height = maxCount < MAX_ASTERISK ? bin : MAX_ASTERISK * (static_cast<double>(bin) / maxCount);
            cout << bin << "|" << string(height, '*');
            cout << "\n";
        }
    }

int main() {
    Input in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins);
    return 0;
}